<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 BVB Media BV - Bas van Beek <bvbmedia@gmail.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */
require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('multishop').'pi1/classes/class.mslib_fe.php');
require_once(t3lib_extMgm::extPath('multishop').'pi1/classes/class.mslib_befe.php');
/**
 * Plugin 'multishop' for the 'multishop' extension.
 *
 * @author	BVB Media BV - Bas van Beek <bvbmedia@gmail.com>
 * @package	TYPO3
 * @subpackage	tx_multishop
 */
global $ms,$get,$server,$post;
class tx_multishop_pi1 extends tslib_pibase {
	var $cObj;    // reference to the calling object. 
	var $prefixId      = 'tx_multishop_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_multishop_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'multishop';	// The extension key.
	var $pi_checkCHash = true;
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array			$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
 	/**
    * Init Function: here all the needed configuration values are stored in class variables
    *
    * @param    array   $conf: configuration array from TS
    * @return   void
	 */
	function construct($conf)
	{
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj=1; 
		$this->pi_initPIflexForm();				
		$this->HTTP_HOST = t3lib_div::getIndpEnv('HTTP_HOST');
		// Get the vhost full path (example: /var/www/html/domain.com/public_html/my_cms/)
		$this->DOCUMENT_ROOT=PATH_site;
		// Get the vhost full path to multishop (example: /var/www/html/domain.com/public_html/my_cms/typo3conf/ext/multishop/)
		$this->DOCUMENT_ROOT_MS=PATH_site.t3lib_extMgm::siteRelPath($this->extKey);
		// Get the vhost full path to TYPO3 (example: /var/www/html/domain.com/public_html/my_cms/typo3/)
		$this->DOCUMENT_ROOT_TYPO3=PATH_site.TYPO3_mainDir;
		// Get the site full URL (example: http://domain.com/my_cms/)
		$this->FULL_HTTP_URL = t3lib_div::getIndpEnv('TYPO3_SITE_URL');		
		// Get the multishop full URL (example: http://domain.com/my_cms/typo3/ext/multishop/ or http://domain.com/my_cms/typo3conf/ext/multishop/)
		$this->FULL_HTTP_URL_MS=t3lib_div::getIndpEnv('TYPO3_SITE_URL').t3lib_extMgm::siteRelPath($this->extKey);
		// Get the full URL (example: http://domain.com/my_cms/typo3/)
		$this->FULL_HTTP_URL_TYPO3=t3lib_div::getIndpEnv('TYPO3_SITE_URL').TYPO3_mainDir;
		$this->get = t3lib_div::_GET();
		$this->post = t3lib_div::_POST();
		// load language cookie for the backend
		$this->cookie = $GLOBALS['TSFE']->fe_user->getKey('ses', 'tx_multishop_cookie');		
//		if (!isset($this->cookie['multishop_admin_language']) and !isset($post['multishop_admin_language'])) $post['multishop_admin_language']='';
		if (isset($post['multishop_admin_language']) and ($post['multishop_admin_language'] != $this->cookie['multishop_admin_language']))
		{
			if ($post['multishop_admin_language']=='default')  $post['multishop_admin_language'] = '';
			$this->cookie['multishop_admin_language'] = $post['multishop_admin_language'];
			$GLOBALS['TSFE']->fe_user->setKey('ses', 'tx_multishop_cookie', $this->cookie);
			$GLOBALS['TSFE']->storeSessionData();
		}	
		$this->cookie = $GLOBALS['TSFE']->fe_user->getKey('ses', 'tx_multishop_cookie');		
		if (strlen($this->cookie['multishop_admin_language'])==2)
		{
			$this->LLkey=$this->cookie['multishop_admin_language'];
			$this->config['config']['language']=$this->cookie['multishop_admin_language'];
		}
		// able to change language by get parameters
		if (strlen($get['language'])==2)
		{
			$this->LLkey=$get['language'];
			$this->config['config']['language']=$get['language'];
		}		
		// load language cookie for the backend eof		
		if (!$GLOBALS['TSFE']->config['config']['baseURL'])
		{
			echo 'config.baseURL='.$this->FULL_HTTP_URL.' is not set yet. Please go to the TYPO3 template setup field editor and add it.';
			die();
		}
		$this->pi_USER_INT_obj = 1;
		$this->REMOTE_ADDR = t3lib_div::getIndpEnv('REMOTE_ADDR');
		if (!$GLOBALS['TSFE']->config['config']['locale_all']) $GLOBALS['TSFE']->config['config']['locale_all']=$this->pi_getLL('locale_all');
		setlocale(LC_TIME,$GLOBALS['TSFE']->config['config']['locale_all']);		
		if ($this->conf['method']) 	$this->method 			= $this->conf['method'];
		else						$this->method 			= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'method', 'sDEFAULT');
		// shop pid
		$this->shop_pid 		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'page_uid', 'sDEFAULT');	
		if (!$this->shop_pid and $this->conf['shop_pid'] > 0)	$this->shop_pid=$this->conf['shop_pid'];
		if(!$this->shop_pid)	$this->shop_pid	=$GLOBALS["TSFE"]->id;	
		// shop pid eof		
		$this->admin_group 		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'admin_group', 'sDEFAULT');
		// var for the tabbed navigation menu
		$this->maxDELIMITED		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'maxDELIMITED', 's_listing');
		$this->lang=$GLOBALS['TSFE']->config['config']['language'];
		$this->sys_language_uid=$GLOBALS['TSFE']->config['config']['sys_language_uid'];		
		if (!isset($this->sys_language_uid)) $this->sys_language_uid=0;		
	}
	function ajax_main($content, $conf){
		/*
			this method is created for returning ajax content.
		*/
		global $ms,$get,$server,$post;
		$this->AJAX_MODE=1;
		self::construct($conf);
		$get=$this->get;
		$post=$this->post;
		//if(!self::$init) self::init($conf);
		include_once(t3lib_extMgm::extPath('multishop').'scripts/application_top_once.php');
		include(t3lib_extMgm::extPath('multishop').'scripts/application_top_always.php');
		require(t3lib_extMgm::extPath('multishop').'scripts/ajax_pages/core.php');		
		return $this->pi_wrapInBaseClass($content);		
	}	
	function main($content, $conf){
		global $ms,$get,$server,$post;	
		self::construct($conf);
		$get=$this->get;
		$post=$this->post;		
		//if(!self::$init) self::init($conf);
		include_once(t3lib_extMgm::extPath('multishop').'scripts/application_top_once.php');		
		include(t3lib_extMgm::extPath('multishop').'scripts/application_top_always.php');
		switch ($this->method)
		{
			case 'custom_script':
			if ($this->custom_script_location)
			{
				require($this->custom_script_location);		
			}
			break;
			case 'meta_tags':	
				include(t3lib_extMgm::extPath('multishop').'scripts/meta_tags.php');	
				if (!$this->ajax_content)
				{
					ksort($meta_tags);
					$meta_tags_html='';
					foreach ($meta_tags as $item)
					{
						$meta_tags_html.=$item;
					}
					// the reason why we have to return the header tags as content is because this section is already mapped to the head tag
					// if we put it in additionalHeaderData the page.headerData order is ignored and it can give annoying conflicts	
					return mslib_fe::processmeta($meta_tags_html);
				}				
			break;
			case 'basket':
			if (strstr($ms['MODULES']['BASKET_TYPE'],"/"))	require($this->DOCUMENT_ROOT.$ms['MODULES']['BASKET_TYPE'].'.php');	
			elseif($ms['MODULES']['BASKET_TYPE'])	include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/content_elements/'.$ms['MODULES']['BASKET_TYPE'].'.php');		
			else require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/content_elements/basket_default.php');
			break;
			case 'manufacturers':
				if (strstr($ms['MODULES']['MANUFACTURERS_TYPE'],"/"))	require($this->DOCUMENT_ROOT.$ms['MODULES']['MANUFACTURERS_TYPE'].'.php');	
				elseif($ms['MODULES']['MANUFACTURERS_TYPE'])	include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/manufacturers_listing/'.$ms['MODULES']['MANUFACTURERS_TYPE'].'.php');		
				else include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/manufacturers_listing/default.php');					
			break;
			case 'categories':
				if (strstr($ms['MODULES']['CATEGORIES_TYPE'],"/"))	require($this->DOCUMENT_ROOT.$ms['MODULES']['CATEGORIES_TYPE'].'.php');	
				elseif($ms['MODULES']['CATEGORIES_TYPE'])	include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/content_elements/'.$ms['MODULES']['CATEGORIES_TYPE'].'.php');		
				else include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/content_elements/categories_default.php');			
			break;	
			case 'search':
				$this->contentType = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'contentType', 's_search');		
				switch ($this->contentType)
				{
					case 'searchform_with_keyword_and_category_dropdown_menu':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/searchform_with_keyword_and_category_dropdown_menu.php');
					break;					
					case 'ultrasearch':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/ultrasearch.php');
					break;								
					case 'price_filter_navigation_box':
					if ($ms['MODULES']['PRICE_FILTER_BOX_STEPPINGS'])
					{
						$this->box_class="multishop_price_filter_box";
						if ($ms['MODULES']['CACHE_FRONT_END'] and !$ms['MODULES']['CACHE_TIME_OUT_CATEGORIES_NAVIGATION_MENU']) $ms['MODULES']['CACHE_FRONT_END']=0;
						if ($ms['MODULES']['CACHE_FRONT_END'])
						{
							$options = array(
								'caching' => true,
								'cacheDir' => PATH_site.'uploads/tx_multishop/tmp/cache/',
								'lifeTime' => $ms['MODULES']['CACHE_TIME_OUT_CATEGORIES_NAVIGATION_MENU']
							);
							$Cache_Lite = new Cache_Lite($options);
							$string='price_filter_'.$server['REQUEST_URI'].$server['QUERY_STRING'].$this->cObj->data['uid'];
						}
						if (!$ms['MODULES']['CACHE_FRONT_END'] or !$content=$Cache_Lite->get($string))
						{		
							$array=explode(";",$ms['MODULES']['PRICE_FILTER_BOX_STEPPINGS']);
							$array[]=$this->pi_getLL('show_all');
							$content.='<ul>';
							if (count($GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar']) >0)
							{
								// get all cats to generate multilevel fake url
								$level=0;
								$cats=$GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar'];
								if(is_array($cats) and count($cats))
								{
									$cats=array_reverse($cats);
								}
								$where='';
								if (count($cats) > 0)
								{
									foreach ($cats as $cat)
									{
										$where.="categories_id[".$level."]=".$cat['id']."&";
										$level++;
									}
									$where=substr($where,0,(strlen($where)-1));
									$where.='&';
								}
								// get all cats to generate multilevel fake url eof
							}
							else $where='';
							$get['skeyword'] = $_REQUEST['skeyword'];	
							$get['skeyword'] = trim($get['skeyword']);
							$get['skeyword'] = $GLOBALS['TSFE']->csConvObj->utf8_encode($get['skeyword'], $GLOBALS['TSFE']->metaCharset);
							$get['skeyword'] = $GLOBALS['TSFE']->csConvObj->entities_to_utf8($get['skeyword'],TRUE);
							$get['skeyword'] = mslib_fe::RemoveXSS($get['skeyword']);
							if ($get['skeyword']) $where.='&skeyword='.urlencode($get['skeyword']).'&';
							foreach ($array as $item)
							{
								if ($item !=$this->pi_getLL('show_all')) $label=$item.' euro';
								else
								{
									$label=$this->pi_getLL('show_all');
								}
								$content.='<li'.($get['price_filter']==$item?' class="active"':'').'><a href="'.mslib_fe::typolink($this->conf['search_page_pid'],'&tx_multishop_pi1[page_section]=products_search&'.$where.'price_filter='.urlencode($item)).'" class="ajax_link">'.$label.'</a></li>'."\n";
							}
							$content.='
							</ul>
							';
							if ($ms['MODULES']['CACHE_FRONT_END'])	$Cache_Lite->save($content);
						}
					}
					break;					
					case 'searchform_with_manufacturers_dropdown_menu':
					$content.='
						<form action="index.php" method="get" name="products_searchform">
						<input name="id" type="hidden" value="'.$this->conf['search_page_pid'].'" />
						<input name="tx_multishop_pi1[page_section]" type="hidden" value="products_search" />
						
						<div class="form-fieldset">
						<select name="manufacturers_id" id="manufacturers_dropdown_menu"><option value="">'.htmlspecialchars($this->pi_getLL('manufacturers')).'</option>						
						';
						$str="SELECT * from tx_multishop_manufacturers m, tx_multishop_manufacturers_info mi where m.manufacturers_id=mi.manufacturers_id and m.status=1 order by m.sort_order,m.manufacturers_name";
						
                        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
						$manufacturers=array();	
						while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
						{
							$manufacturers[]=$row;
						}
						if (count($manufacturers) > 0)
						{
							foreach ($manufacturers as $manufacturer)
							{
								$content.='<option value="'.$manufacturer['manufacturers_id'].'"'.($get['manufacturers_id']==$manufacturer['manufacturers_id']?' selected':'').'>'.htmlspecialchars($manufacturer['manufacturers_name']).'</option>'."\n";
							}
						}
						$content.='</select>						
						</div>
						</form>
						<script>
							jQuery("#manufacturers_dropdown_menu").change(function() {
							   jQuery(this).closest("form").submit();
							});						
						</script>';						
					break;
					case 'default':
					default:
					if ($this->conf['includejAutocomplete'])
					{						
						$GLOBALS['TSFE']->additionalHeaderData[]='<script type="text/javascript">
								  jQuery(document).ready(function($) {
									var sendData;														  
									jQuery("#skeyword").bind("focus",function(){
										jQuery("#page").val(0);
									})
									jQuery("#skeyword").bind("keydown.autocomplete",function(e){
										// dont process special keys
										var skipKeys = [ 13,38,40,37,39,27,32,17,18,9,16,20,91,93,8,36,35,45,46,33,34,144,145,19 ];
										if (jQuery.inArray(e.keyCode, skipKeys) != -1) sendData = false;
										else sendData = true;																													
									})							
									jQuery("#skeyword").autocomplete({
										//console.log(this);
										minLength: 1,
										delay: 250,
										open: function(event, ui){
											jQuery(".ui-autocomplete").attr("id", "ui-autocomplete-front");																										
										  	jQuery(".ui-autocomplete li.ui-menu-item:odd a").addClass("ui-menu-item-alternate");
										},										
										source: function( request, response ) {
												if (sendData){		
												jQuery.ajax({
													url: "'. mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=ajax_products_search') .'",
													dataType : "json",
													timeout : 10000,
													data: {
														q: jQuery("#skeyword").val(), page: jQuery("#page").val()
													},
													success: function( data ) {
														var index = 1;
														 if(data.products != null){
															response( jQuery.map( data.products, function( item ) {
																index = index + 1;
																 
																	if (index == 6) {
																		return {
																			label: item.Title,
																			value: item.Name,
																			link: item.Link,
																			skeyword: item.skeyword,
																			page: item.Page,
																			prod: item.Product
																		}
																	} else {
																		return {
																			label: "<div class=\"ajax_products_image_wrapper\">"+item.Image + "</div><div class=\"ajax_products_search_item\">" + item.Title  + item.Desc + item.Price + "</div>",
																			value: item.Name,
																			link: item.Link,
																			skeyword: item.skeyword,
																			page: item.Page,
																			prod: item.Product
																		}
																	}
																 
																})
															);
														 } //end if data
														//alert(index);
													}
												});
												} // and if sendData
											},
										select: function(event, ui ) {
														 jQuery("#skeyword").val(ui.item.skeyword);
														 jQuery("#page").val(ui.item.page);
														//console.log(ui);
														//alert(ui.toSource());
														var link = "'.$this->FULL_HTTP_URL.'" + ui.item.link ; 
														//alert(link);
														if (ui.item.prod == true){
															open(link,\'_self\',\'resizable,location,menubar,toolbar,scrollbars,status\');
														} else {
															jQuery("#skeyword").autocomplete("search");
														}
													},
										focus: function(event, ui) {
											jQuery("#skeyword").val(ui.item.skeyword);
											jQuery("#page").val(0);
											return false;
										}	
									}).data(\'autocomplete\')._renderItem = function (ul, item) {
										return jQuery("<li></li>").data("item.autocomplete", item).append(jQuery("<a></a>").html(item.label)).appendTo(ul);
										};
								  });
							</script>';		
					}					
					$content.='
						<form action="index.php" method="get" name="products_searchform">
						<input name="id" type="hidden" value="'.$this->conf['search_page_pid'].'" />
						<input name="tx_multishop_pi1[page_section]" type="hidden" value="products_search" />						
						<div class="form-fieldset">
							<label for="skeyword">'.$this->pi_getLL('keyword').':</label>
							<input name="skeyword" type="text" value="'.htmlspecialchars(mslib_fe::RemoveXSS($get['skeyword'])).'" id="skeyword" />
							<input name="page" type="hidden" value="0" id="page" />						
							<input name="Submit" type="submit" value="'.htmlspecialchars($this->pi_getLL('search')).'" />
						</div>
						</form>
					';							
					break;
				}
			break;				
			case 'specials':
				$this->section_code = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'section_code', 's_specials');
				$this->box_class='multishop_specials';
				$this->contentType = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'contentType', 's_specials');
				$this->limit = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'speciallimit', 's_specials');			
				if (!$this->limit) $this->limit='10';
				$content.=mslib_fe::SpecialsBox($this->contentType,$this->limit,$this->showCatalogFromPage,$this->cObj->data['uid']);
			break;
			case 'products':
				$this->contentType = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'contentType', 's_products_listing');
				switch ($this->contentType)
				{
					case 'products_new':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/products_new.php');
					break;
					case 'products_modified':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/products_modified.php');
					break;
					case 'products_upcoming':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/products_upcoming.php');
					break;
					case 'products_upcoming':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/products_upcoming.php');
					break;
					case 'products_hot':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/products_hot.php');
					break;
					case 'products_last_visited':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/products_last_visited.php');
					break;
				}
			break;
			case 'misc':
				$this->contentMisc = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'contentType', 's_misc');
				switch ($this->contentMisc)
				{					
					case 'shopping_cart':
						$content.='<div id="tx_multishop_pi1_core">';
						if (strstr($ms['MODULES']['SHOPPING_CART_TYPE'],"..")) die('error in SHOPPING_CART_TYPE value');
						else 
						{
							if (strstr($ms['MODULES']['SHOPPING_CART_TYPE'],"/"))
							{
								// relative mode
								require($this->DOCUMENT_ROOT.$ms['MODULES']['SHOPPING_CART_TYPE'].'.php');	
							}
							else
							{
								include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/shopping_cart/default.php');	
							}
						}										
						$content.='</div>';
					break;
					case 'checkout':
						$content.='<div id="tx_multishop_pi1_core">';					
						if (strstr($ms['MODULES']['CHECKOUT_TYPE'],"..")) die('error in CHECKOUT_TYPE value');
						else 
						{
							if (strstr($ms['MODULES']['CHECKOUT_TYPE'],"/"))
							{
								// relative mode
								require($this->DOCUMENT_ROOT.$ms['MODULES']['CHECKOUT_TYPE'].'/checkout.php');	
							}
							else
							{
								require(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/checkout/'.$ms['MODULES']['CHECKOUT_TYPE'].'/checkout.php');	
							}
						}						
						$content.='</div>';
					break;					
					case 'ajax_remote_search':
						$content.='<input name="skeywords" id="skeywords" type="text" /><div id="searchForm"></div>';
						$content.='
						<script type="text/javascript">
						// validate username
						jQuery(document).ready(function($) {
						  var searchForm = jQuery(\'#searchForm\');
						  jQuery(\'#skeywords\').keyup(function () {
							var t = this; 
							if (this.value != this.lastValue) {
							  if (this.timer) clearTimeout(this.timer);
							  searchForm.removeClass(\'error\').html(\'<img src="'.$this->FULL_HTTP_URL_MS.'templates/images/loading2.gif" height="16" width="16" /> loading...\');
							  this.timer = setTimeout(function () {
								jQuery.ajax({
								  url: \''.mslib_fe::typolink(',2002','&tx_multishop_pi1[page_section]=ajax_remote_search').'\',
								  data: \'&skeyword=\' + t.value,
								  dataType : "json",
							      timeout : 10000,
								  type: \'post\',
								  success: function (j) {
									searchForm.html(j.msg);
								  }
								});
							  }, 200);
							  this.lastValue = this.value;
							}
						  });
						});
						</script>				
						';
						break;
					case 'create_account':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/create_account.php');
					break;
					case 'edit_account':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/edit_account.php');
					break;
					case 'store_locator':
						include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/store_locator.php');
					break;
					case 'order_history':
						$content.='<div id="tx_multishop_pi1_core">';					
						if (mslib_fe::loggedin())
						{
							if (strstr($ms['MODULES']['ORDER_HISTORY_TYPE'],"..")) die('error in ORDER_HISTORY_TYPE value');
							else 
							{
								if (strstr($ms['MODULES']['ORDER_HISTORY_TYPE'],"/"))
								{
									// relative mode
									require($this->DOCUMENT_ROOT.$ms['MODULES']['ORDER_HISTORY_TYPE'].'.php');	
								}
								else
								{
									include(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/order_history/default.php');	
								}
							}
						}
						$content.='</div>';
					break;					
					case 'currency_selector':
						require_once('front_pages/includes/content_elements/currency_selector.php');	
					break;
					default:
						// more items could be added through hook
						$filePath='';
						if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/pi1/class.tx_multishop_pi1.php']['contentMisc']))
						{
							$params = array (
								'contentMisc' => &$this->contentMisc,
								'filePath' => &$filePath,								
							); 
							foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/pi1/class.tx_multishop_pi1.php']['contentMisc'] as $funcRef)
							{
								t3lib_div::callUserFunction($funcRef, $params, $this);
							}
						}
						if ($filePath)
						{
							require_once($filePath);	
						}
					break;
				}
			break;
			case 'coreshop':
			require(t3lib_extMgm::extPath('multishop').'scripts/core.php');			
			if ($this->conf['show_powered_by_multishop'])
			{
				$content.='
				<div class="align_center" id="typo3multishop_logo">
					<a href="http://www.typo3multishop.com/?utm_source=Typo3Website&utm_medium=cpc&utm_term=Typo3Multishop&utm_content=Listing&utm_campaign=Typo3Multishop" title="Powered by TYPO3 Multishop" target="_blank"><img src="'.$this->FULL_HTTP_URL_MS.'templates/images/powered_by_typo3multishop.png" border="0" alt="Powered by TYPO3 Multishop" title="Powered by TYPO3 Multishop"></a>
				</div>
				';
			}
			break;
		}
		if ($this->hideIfNoResults and $this->no_database_results)
		{
			// when the content element in TYPO3 has been configured with hideIfNoResults = true then hide the content if there is no data fetched from the database
			$this->cObj->data['header']='';
			$this->hideHeader=1;
			return '';
		}
		if ($this->showBoxless)
		{
			$this->hideHeader=1;
			return $this->pi_wrapInBaseClass($content);
		}		
		elseif ($this->addBox or $this->box_class)
		{
			if ($this->hideHeader)
			{
				$this->cObj->data['header']='';
			}
			$content=mslib_fe::typobox($this->cObj->data['header'],$content,$this->box_class);
		}
		elseif (!$this->hideHeader)
		{
			if (!$this->hideIfNoResults and $this->no_database_results) 
			{
				$content = $this->cObj->cObjGetSingle(
					$GLOBALS['TSFE']->tmpl->setup['lib.']['stdheader'],
					$GLOBALS['TSFE']->tmpl->setup['lib.']['stdheader.']
				) . $content;
//				$content = $this->cObj->cObjGetSingle('<tt_content','') . $content;
			}
		}	
		return $this->pi_wrapInBaseClass($content);
	}
}
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/multishop/pi1/class.tx_multishop_pi1.php'])
{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/multishop/pi1/class.tx_multishop_pi1.php']);
}
?>