<?php

/**
* TargetPay Wallie example class
* 
*  SVE
*  04-03-20010
*/
  
# requires the init class
require_once ( 'TargetPay.class.php' );
  
class TargetPayWallie extends TargetPay {
    
public $iCountry = '31';
public $iCurrency = 'EUR';
public $iLanguage = 'NL';
    
  
  # ofcourse construct
  public function __construct( $intRtlo ) {
    
    # call parent constructor 
    parent::__construct( $intRtlo );
      
  }
  
  /**
  * @Desc start payment
  * @Return array ( trxid, WallieReturnUrl )
  */
  
  public function startPayment () {
      
      try {
          
          
          # Build parameter string
          //$aParameters = $this->getBaseRequest();
          $aParameters = array();
          $aParameters['rtlo'] = $this->intRtlo;
          $aParameters['description'] =$this->strDescription;
          $aParameters['currency'] = $this->iCurrency;
          $aParameters['country'] = $this->iCountry;
          $aParameters['language'] = $this->iLanguage; 
          $aParameters['amount'] =  $this->WallieAmount;
          $aParameters['userip'] = $_SERVER['REMOTE_ADDR'];
          $aParameters['returnurl'] = $this->strReturnUrl;
          $aParameters['reporturl'] = $this->strReportUrl;
          
          # do request
          $strResponse = $this->getResponse( $aParameters, 'https://www.targetpay.com/wallie/start?');
          $aResponse = explode('|', $strResponse );

          # Bad response
          if ( !isset ( $aResponse[1] ) ) {
            throw new Exception( 'Error ' . $aResponse[0] );    
          }
          
          $iTrxID = explode ( ' ', $aResponse[0] );
          
          # We return TRXid and url to rederict
          return array ( $iTrxID[1], $aResponse[1] );
              
      } 
      catch( Exception $e ) {
      
        # error, could not proceed 
        echo $e->getMessage();
      
      }    
  }
  
  /**
   * Validate the payment now by trxId
   *
   * @return bool
   */
   
   public function validatePayment ( $intTrxId, $iOnce = 1, $iTest = 0 ) {
       
       try {
        
           # Build parameter string
           $aParameters = array();
           $aParameters['rtlo'] = $this->intRtlo;
           $aParameters['trxid'] = $intTrxId;
           $aParameters['once'] = $iOnce;
           $aParameters['test'] = $iTest; 
           
           # do request
           $strResponse = $this->getResponse ( $aParameters , 'https://www.targetpay.com/wallie/check?');
           $aResponse = explode('|', $strResponse );
           
           # Bad response
           if (  $aResponse[0] != '000000 OK' ) {
                throw new Exception( $aResponse[0] );    
           }
           
           return true;
       
       }    
       catch( Exception $e ) {
      
        # error, could not proceed 
        //echo $e->getMessage();
      
      } 
               
   }
   
   /**
   * @desc Set country
   */
   
  public function setWallieCurrency ( $strCurrency ) {
    $this->iCurrency = $strCurrency;
    return $this;   
  }
   
   /**
   * @desc Set country
   */
  public function setWallieCountry ( $intCountry ) {
    $this->iCountry = $intCountry;
    return $this;   
  }
  
     /**
   * @desc Set Language
   */
  public function setWallieLang ( $intLang ) {
    $this->iLanguage = $intLang;
    return $this;   
  }
  
  /**
  * 
  * @Desc set Wallie return url
  * 
  */
  
  public function setWallieReturnUrl ( $strReturnUrl ) {
    $this->strReturnUrl = $strReturnUrl;  
     return $this;   
  }
  
  public function setWallieReportUrl ( $strReportUrl ) {
  	$this->strReportUrl = $strReportUrl;
  	return $this;
  }
  
  /**
  * 
  * @Desc set Wallie description for transaction
  * 
  */
  
  public function setWallieDescription ( $strDescription ) {
    $this->strDescription = $strDescription;  
     return $this;   
  }
  
  /**
  * @Desc set Wallie amount
  * 
  */
  
  public function setWallieAmount ( $intWallieAmount ) {
    
      # Is this a valid Wallie amount?
      if ( is_numeric ( $intWallieAmount ) && $intWallieAmount > 0 ) {
        $this->WallieAmount = $intWallieAmount;    
      }
      else {
        throw new Exception( 'Invalid Wallie amount, please check.' );   
      }
       return $this;
  }
    

  
}
  
  
?>
