<?php
/*
Google Checkout
*/

// Include all the required files
require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/google_checkout/library/googlecart.php');
require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/google_checkout/library/googleitem.php');
require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/google_checkout/library/googleshipping.php');
require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/google_checkout/library/googletax.php');

//Create a new shopping cart object
$merchant_id = $vars['merchant_id'];  // Your Merchant ID
$merchant_key = $vars['merchant_key'];  // Your Merchant Key

if ($vars['test']=='true') {
	$server_type = "sandbox";
} else {
	$server_type = "production";
}

$currency = 'USD'; //$ms['MODULES']['CURRENCY_ARRAY']['cu_iso_3'];
$cart = new GoogleCart($merchant_id, $merchant_key, $server_type, $currency);

foreach ($order['products'] as $idx => $product) {
	$item = new GoogleItem($product['products_name'], // product name 
						 $product['products_description'], // product mini description/model
						 (int) $product['qty'], // qty
						 number_format($product['total_price'], 2, '.', '')); // price
    
	$attributes_holder = array();
	if (count($product['attributes']) > 0) {
		foreach($product['attributes'] as $at_idx => $attributes) {
			$attributes_holder[$attributes['products_options']] = $attributes['products_options_values'];
			
		}
		
		$item->SetMerchantPrivateItemData(new MerchantPrivateItemData($attributes_holder));
	}
	
    $cart->AddItem($item);
}

if ($order['shipping_method_costs'] > 0) {
	$shipping_item = new GoogleItem('Shipping cost: '.$order['shipping_method_label'], // product name 
						 '', // product mini description/model
						 1, // qty
						 number_format($order['shipping_method_costs'], 2, '.', '')); // price
	
	$cart->AddItem($shipping_item);
}

if ($order['payment_method_costs'] > 0) {
	$payment_item = new GoogleItem('Payment cost: '.$order['payment_method_label'], // product name
			'', // product mini description/model
			1, // qty
			number_format($order['payment_method_costs'], 2, '.', '')); // price

	$cart->AddItem($payment_item);
}

$transaction_id=mslib_fe::createPaymentTransactionId($order['orders_id'],'google_checkout',$order['payment_method'], 'md5_short');
$cart->SetMerchantPrivateData(new MerchantPrivateData(array("cart-id" => $transaction_id)));

$content .= $cart->CheckoutButtonCode("LARGE");
	
if ($vars['autosubmit']=='true')
{
	$content.= '<script type="text/javascript" language="JavaScript">
					jQuery(document).ready(function(){
						jQuery.blockUI({ css: { 
							width: \'350\', 
							border: \'none\', 
							padding: \'15px\', 
							backgroundColor: \'#000\', 
							\'-webkit-border-radius\': \'10px\', 
							\'-moz-border-radius\': \'10px\', 
							opacity: .5, 
							color: \'#fff\'
							}, 
							message:  \'ONE MOMENT PLEASE\',
							onBlock: function() { 
								jQuery("#pspform").attr(\'target\',\'\');
								jQuery("#pspform").submit();
						//		return true;
							} 
						}); 													

					});
				</script>';
}
?>